const logger = require('@turnkeyvr/logger');
const csv = require('fast-csv');
const fs = require('fs');
const path = require('path');
const csvWriter = require('csv-writer');

exports.createCsvWriter = csvWriter.createObjectCsvWriter;

exports.loadCSV = async () => {
    let records = [];
    return new Promise((resolve, reject) => {
        let csvPath = path.resolve(__dirname, './files/CouponCodes.csv');
        logger.debug('csvPath: ', csvPath);
        fs.createReadStream(csvPath)
            .pipe(csv.parse({headers: true}))
            .on('data', row => {
                records.push(row);
            })
            .on('error', error => {
                logger.error(error);
                reject();
            })
            .on('end', () => {
                resolve(records);
            });
    });
};