const mongoUtil = require('../util/mongoUtil');
const s3Util = require('../util/s3Util');

const logger = require('@turnkeyvr/logger');
const async = require('async')
const awsSns = require('@turnkeyvr/aws_sns');
const { promisify } = require("util");
const util = require('util');
const papa = require('papaparse');

const promiseSendSns = promisify(awsSns.publishEmail);

exports.handler = async () => {
    logger.info('running monitorRates!')

    let downloadRateGridMsg = {
        callingProcess: "monitorRatesProject",
        reportType: "Rate Action Grid",
        fileFormat: "CSV",
        reportParams: {}
    };

    await promiseSendSns('arn:aws:sns:us-east-2:673853704728:escapia-robotify-report-download-request',
        'MONITOR_RATES', JSON.stringify(downloadRateGridMsg))

    return
}

exports.workerHandler = async (event, context) => {
    // let message =  JSON.parse(event.Records[0].Sns.Message);

    // for testing
    message = {
        reportType:'Rate Action Grid',
        success: true,
        s3Bucket:'robotify-escapia-reports',
        s3Key:'obhwAvsAhYPl5cIYRQ5ZZuvO/Rate Action Grid.csv'
    }

    if ( message.success && message.reportType === 'Rate Action Grid' ) {
        var params = {
            Bucket: message.s3Bucket,
            Key: message.s3Key
        };

        let responseObject = await s3Util.getObject(params)
        let rateGridReportData = responseObject.Body.toString('utf-8');

        let rateGridReportObj = papa.parse(rateGridReportData, {header: true})
        // logger.info('results: ' + JSON.stringify(rateGridReportObj.data))

        // let knownRates = await mongoUtil.find('currentRates', {})


        for ( let idx=0; idx<rateGridReportObj.data.length; idx++ ) {
            let rateFromEscapia = rateGridReportObj.data[idx]
            // logger.info(JSON.stringify(Object.keys(rateFromEscapia)))

            if ( typeof rateFromEscapia.Name != 'undefined' && rateFromEscapia.Name.indexOf('Automation') == 0 ) {
                // logger.info('Not undefined' + rateFromEscapia.Name)

                let firstIdx = rateFromEscapia.Name.indexOf('-') + 2
                let secondIdx = rateFromEscapia.Name.lastIndexOf('-') - 1
                let dateMatchStr = rateFromEscapia.Name.substring(firstIdx, secondIdx).trim()

                firstIdx = rateFromEscapia.Name.lastIndexOf(':') + 1
                let minstay = rateFromEscapia.Name.substring(firstIdx).trim()

                logger.info(dateMatchStr, minstay)

            }

        }

    }

    return true
}