const fs = require('fs');
const path = require('path');
const json2csv = require('json2csv').parse;
const mkdirp = require('mkdirp');

function getFilePath(fileLocation){
    const fileDetails = (typeof fileLocation === "string") ? {fileName: fileLocation} : {...fileLocation};
    if (!fileDetails.fileName) fileDetails.fileName = "default";
    if (!/\.csv$/gi.test(fileDetails.fileName)) fileDetails.fileName = `${fileDetails.fileName}.csv`;
    let basePath = process.cwd();
    if (fileDetails.subDir) basePath = path.join(basePath, fileDetails.subDir);
    mkdirp.sync(basePath);
    return path.join(basePath,fileDetails.fileName);
}

/**
 * 
 * @param {*} data - data to write to csv
 * @param {* | String} fileLocation - can be a file name as string. Or an object with the properties: fileName, subDir. File name can have extension or not.
 */
exports.createCsv = (data, fileLocation) => {
    const fields = Array.isArray(data) ? Object.keys(data[0]) : Object.keys(data);
    const csv = json2csv(data,{fields});
    const location = getFilePath(fileLocation);
    fs.writeFileSync(location,csv);
}