const logger = require('@turnkeyvr/logger');
const { sleep } = require('../util/misc');
const { getSelectOptions } = require('../util/selectOptionsUtil');

exports.setUnitGroup = async (page, unitGroupName, snsMsgId, unitGroupArr) => {
    if ( snsMsgId = null )
        snsMsgId = 'Unknown'

    // logger.info(snsMsgId + ': doing unitGroupName ' + unitGroupName)
    await page.goto('https://turnkeyvr.escapia.com/webagency/Property/ManageUnitGroups.aspx?ugt=1&ugmt=1', {waitUntil: 'load'});

    await page.evaluate(() => document.getElementById("txtUnitGroupName").value = "")
    await page.focus('#txtUnitGroupName');
    await page.keyboard.press('Backspace');
    await page.keyboard.type(unitGroupName);
    await page.keyboard.press('Enter')

    try {
        await page.waitForSelector('#rptUnitGroups_ctl01_tdName');
    }
    catch (ex) {
        await page.waitForSelector('#pnlNoResults');
        logger.info('UnitGroup does not exist - needs to be fixed: ' + unitGroupName)
        return
    }

    let name = await page.$eval('#rptUnitGroups_ctl01_tdName', name => name.innerText);
    if ( name == unitGroupName ) {
        await page.click('#rptUnitGroups_ctl01_tdName', {waitUntil: 'networkidle0'});
        await page.waitForSelector('select#dlstUnits_RightBox');

        let options = await getSelectOptions(page, 'select#dlstUnits_RightBox > option' );
        // console.log('options: ' + JSON.stringify(options))
        await page.select('select#dlstUnits_RightBox', ...options.values);
        await page.click('#dlstUnits_MoveLeft');


        let selectArr = []
        options = await getSelectOptions(page, 'select#dlstUnits_LeftBox > option' );
        for ( let idx=0; idx<options.namesAndValues.length; idx++ ) {
            for ( let nIdx=0; nIdx<unitGroupArr.length; nIdx++ ) {
                if ( options.namesAndValues[idx].name.indexOf(unitGroupArr[nIdx]) > -1 ) {
                    selectArr.push(options.namesAndValues[idx].value)
                    break
                }
            }
        }

        await page.select('select#dlstUnits_LeftBox', ...selectArr);
        await page.click('#dlstUnits_MoveRight');
        await page.click('#btnSave');
    }
    else {
        console.log('no selector match ' + name + ' :::: ' + unitGroupName)
    }

    await sleep(5000); // this may not be needed
    return page;
};
