/* usage:

// one thing
await retry(
    () => page.waitForXPath('//*[contains(@class, ".customer_name")]/ancestor::li'),
    5 // retry this 5 times
);

// set of things
await retry(
    () => Promise.all([
        page.goto(url),
        page.waitForNavigation({ waitUntil: 'domcontentloaded' }),
    ]),
    1 // retry only once
);
*/

exports.retry = async function retry(promiseFactory, retryCount) {
    try {
        return await promiseFactory();
    } catch (error) {
        if (retryCount <= 0) {
            throw error;
        }
        return await retry(promiseFactory, retryCount - 1);
    }
}