const AWS = require('aws-sdk');
const env = require('@turnkeyvr/env');
const util = require('util');

AWS.config.region = 'us-east-2';
AWS.config.apiVersions = {
    sns: '2010-03-31'
};

const s3 = new AWS.S3({
    credentials: {
        accessKeyId: env.config.get('robotify.aws.accessKeyId'),
        secretAccessKey: env.config.get('robotify.aws.secretAccessKey'),
    }
});

s3.putObject = util.promisify(s3.putObject);
s3.getObject = util.promisify(s3.getObject);
s3.deleteObject = util.promisify(s3.deleteObject);

exports.putObject = async (params) => {

}

// https://docs.aws.amazon.com/AWSJavaScriptSDK/latest/AWS/S3.html#getObject-property
exports.getObject = async (params) => {
    return await s3.getObject(params)
}

exports.deleteObject = async (params) => {
    return await s3.deleteObject(params)
}