
exports.getSelectOptions = async (page, selector) => {
    const options = await page.evaluate(optionSelector => {

        return {
            namesAndValues: Array.from(document.querySelectorAll(optionSelector))
                .filter(o => o.value)
                .map(o => {
                    return {
                        name: o.text,
                        value: o.value,
                        selected: o.selected
                    };

                }),
            values: Array.from(document.querySelectorAll(optionSelector))
                .filter(o => o.value)
                .map(o => {
                    return o.value;
                })
        }

    }, selector);

    return options;
}